import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.util.zip.*;
import javax.servlet.*;
import javax.servlet.http.*;
import HTTPClient.*;

/** 
 * SeSeConnection: the main part of the API which is used by the client application
 * to communicate with the server
 * @author sandy
 */
public class SeSeConnection {
   URL Posturl;
   Hashtable HT=new Hashtable();
   String clientID=null;
   CipherClient crypt=null;
   // boolean fl=false;
/**
 * parameters clientID: the ID of the client
 * clientSkFile the name of the client's Secret Key file name
 * serverPkFile the name of the server's Public Key file name
 * URL is the url of the server
 */
   public SeSeConnection(String clientID, String clientSkFile, String serverPkFile, URL url) {
      this.Posturl=url;
      this.clientID=clientID;
      try {
        this.crypt = new CipherClient(clientID, clientSkFile, serverPkFile);
      } catch (Exception e) { System.err.println("file misplaced"); }
   }
   
   /**
    * registers object of request, and parameters
    */
   public void registerRequest(String name, String value) {
      HT.put(name, value);
   }
   
   /**
    * registers the demands of fields
    */
   public void registerRequest(String name) {
      this.registerRequest(name, "");
   }
   /**
    * Flushes the request to the server at the given URI
    */
   public void PostObject(String URI) {
      HTTPResponse postResp=null;
      Hashtable tmp=new Hashtable();
      try {
         HTTPConnection postConn=new HTTPConnection(Posturl);
         postResp=postConn.Post(URI, crypt.getCryptedStream(HT));
         tmp=(Hashtable)crypt.getDecryptedObject(postResp.getData());
      } catch ( Exception anyex ) {
         anyex.printStackTrace();
         HT.put("response","false");
         return;
      }
      if (!tmp.containsKey("response")) tmp.put("response","true"); // to take care of server side gotchas
      HT=tmp;
   }
/**
 * returns the value of given field
 */
   public String getValue(String name) {
      return (String)HT.get(name);
   }
}
