import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import PassField;
import java.sql.*;
import java.net.*;
import PrintPage;
import Mailer;

/**
 * This class gets the form data and compares the crypted password for
 * the user with that stored in the Server Database and sets a cookie at
 * the browser end, at the same time storing it with the Server, if the
 * user has authenticated himself.If the authentication fails then a
 * mail is sent to the user, so that he can know of any attempt 
 * @author bhalotia
 */
public class LoginHandler extends HttpServlet {

  public static String passwd;
  public static java.sql.Connection myCom=null;
  int ExpiryTime   = 1500000; // seconds( arbitrary, just a large value)
  PrintPage Page = new PrintPage();

  /**
   * This method handles data received when secure method is used, the
   * password is already crypted and it just invokes the CommonFunc
   * method.
   */
  public void doGet(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException, IllegalStateException  {
      passwd = req.getParameter("challenge");
      CommonFunc(req,res);
    }

  /**
   * This method handles data received when insecure method is used, the
   * password is crypted and the CommonFunc method is invoked.For
   * crypting it uses the getChallenge method of the PassField class.
   */
  public void doPost(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException, IllegalStateException  {
      passwd = req.getParameter("passwd");
      passwd = ( new PassField() ).getChallenge(passwd);
      CommonFunc(req,res);
    }

  public void CommonFunc( HttpServletRequest req,HttpServletResponse res) 
    throws IOException {


      res.setContentType("text/html");
      PrintWriter out =res.getWriter();
      //get the user's name and password
      String name = req.getParameter("name");



      try {
	DBConnect();

	//check the name and password for validity
	if(!allowUser(name, passwd)) {
	  Page.putHeader(out, "Wrong Password/Login Doesn't Exist");
	  res.setHeader("refresh","5;URL=/login.shtml");
	  Page.putFooter(out);
	  Mailer ml = new Mailer(UserEmail(name), 
	      "Subject: Authentication Failure\n\n"+
	      "For user "+name+" there was a login misattempt");
	  ml.start();
	  Mailer ml1 = new Mailer(UserEmail("root"), 
	      "Subject: Authentication Failure\n\n"+
	      "For user "+name+" there was a login misattempt");
	  ml1.start();

	}
	else { 
	  Random SR=new Random((new  java.util.Date()).getTime());
	  byte[] HumaraCookie    = new byte[6];
	  SR.nextBytes(HumaraCookie);
	  String arbitcookie = URLEncoder.encode((new String(HumaraCookie)));
	  String arbitcookie1= URLEncoder.encode( arbitcookie);
	  //	     arbitcookie = "sandy";

	  Cookie cooky=new Cookie("Challenge",arbitcookie1);//session.getId());
	  cooky.setDomain(".cse.iitb.ernet.in");
	  cooky.setPath("/");
	  cooky.setMaxAge(ExpiryTime);
	  res.addCookie(cooky);
	  try {
	    CookieInJar.CookieDelete(name,null);
	    CookieInJar.CookieSave(name, arbitcookie, 
		((int)((new java.util.Date()).getTime()/1000)));
	  } catch (SQLException e) {out.println(e); }
	  // session.invalidate();
	  out.println(req.getParameter("referrer"));
	  try {
	  if(req.getParameter("referrer").equals("http://everest.cse.iitb.ernet.in:1024/liby/Liby"))
	    res.sendRedirect(req.getParameter("referrer"));
	  else{
	    if(name.equals("root"))
	      res.sendRedirect(req.getScheme() + "://"+ 
		  req.getServerName() + ":" + req.getServerPort() + "/admin_menu.shtml");
	    else	res.sendRedirect(req.getScheme() + "://"+ 
		req.getServerName() + ":" + req.getServerPort() + "/user_menu.shtml");
	  }
	  } catch (Exception ignore) { }


	}
	myCom.close();}
	catch (SQLException e) {out.println("SQLException occured"+e);}
    }

  /*
   * checks if a user has given a valid passwrod
   */
  protected boolean allowUser( String user, String passwd)
    throws SQLException {
      String qry = "select passwd from users where user_id = '"+user+"'";
      Statement stmt=myCom.createStatement();
      ResultSet rs=stmt.executeQuery(qry);
      int pass1=0;
      if(rs.next()){
	String stored =rs.getString("passwd");	
	if(passwd.equals(stored))
	  return true;
	else
	  return false;
      }
      else	
	return false;
    }

  /*
   * Gets the email id of teh given user
   */
  protected String UserEmail( String user)
    throws SQLException {
      String qry = "select email_id from users where user_id = '"+user+"'";
      Statement stmt=myCom.createStatement();
      ResultSet rs=stmt.executeQuery(qry);
      int pass1=0;
      if(rs.next()){
	String stored =rs.getString("email_id");	
	return stored;
      }
      return null;
    }


  /*
   * This method opens a SQL connection.
   */
  private static void DBConnect() throws SQLException {
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
    myCom =
      DriverManager.getConnection("jdbc:oracle:thin:@everest:1521:GEN","userinfo","fighter");
  }

}

