import java.lang.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import PrintPage;

/**
 * This class deals with requests corresponding to the application menu,
 * The class has methods to handle addition, deletion and modification of
 * application records.
 * @author vivek, bhalotia
 * */

public class SysAdFuncs1 extends HttpServlet{
  public static java.sql.Connection myCom=null;
  public static PrintWriter out;
  public static Cookie[] cooki;

  /*
   * This method calls other methods to first check whether the user has 
   * been authenticated, and then calls the appropriate method according
   * to the operation.
   */

  public void doGet(HttpServletRequest req,HttpServletResponse res) throws IOException,ServletException{
    try{
      res.setContentType("text/html");
      out = res.getWriter();
      PrintPage Page=new PrintPage();
      out.println("<center>");
      DBConnect(res);
      boolean authentic=CheckCookie(req,res);			
      if(authentic==false){          // operations not allowed to invalid user
	Page.putHeader(out,"ERROR: INVALID USER !");
	out.println("<center>You are not allowed to perform this Operation</center>");
	res.setHeader("refresh","5; URL=/login.shtml");
      }
      else{
	// operation performed according to value of hidden field - id
	String id=req.getParameter("id");

	if(id.equals("1.1")){
	  Page.putHeader(out,"Add Applications");
	  AddAppl(req, res);
	} 
	if(id.equals("1.2")){
	  Page.putHeader(out,"Delete Application");
	  DelAppl(req,res);
	}     
	if(id.equals("1.3")){
	  Page.putHeader(out,"Modify Application");
	  FillForm(req,res);
	}
	if(id.equals("1.4")){
	  Page.putHeader(out,"Modify Application");
	  ModifyAppl(req, res);
	}     
      }		
      Page.putFooter(out);
      myCom.close();

    }catch(SQLException sqle){
      out.println("<center>SQL Exception" + sqle+"</center>");
      res.setHeader("refresh","5; URL=/appwork.shtml");
    }	
  }

  /*
   * This method checks for a cookie for the user both in the browser
   * and in the database, further checking if they are equal. If so
   * true is returned else false.
   */
  private static boolean CheckCookie(HttpServletRequest req,HttpServletResponse res){
    Cookie[] cooki=req.getCookies();
    for(int i=0;i<cooki.length;i++){
      if(cooki[i].getName().equals("Challenge")){
	String qry="select user_id from cookie_jar where cookie='"+cooki[i].getValue()+"'";
	try{
	  Statement stmt=myCom.createStatement();
	  ResultSet rs=stmt.executeQuery(qry);
	  while(rs.next()){
	    String usr=rs.getString("user_id");
	    // only root is allowed these functions
	    if(usr.equals("root"))
	      return true;
	  }
	}catch(SQLException sqle){
	  out.println("<center>SQLException :"+sqle+"</center>");
	  res.setHeader("refresh","5; URL=/appwork.shtml");
	}
      }	
    }
    return false;
  }

  /* 
   * This method opens a connection to the database.
   */
  private static void DBConnect(HttpServletResponse res) {
    try{
      DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
      myCom =
	DriverManager.getConnection("jdbc:oracle:thin:@everest:1521:GEN","userinfo","fighter");
    }
    catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/appwork.shtml");
    }
  }

  /* 
   * This method adds a new application record to the database.
   * It also uploads the public-key of the application to be stored in the 
   * database.
   */
  public static void AddAppl(HttpServletRequest req, HttpServletResponse res) throws IOException,SQLException {
    try{	
      String app_id = req.getParameter("app_id");
      String app_name = req.getParameter("app_name");
      String pub_key = req.getParameter("pub_key");		 	 
      String hname = req.getParameter("hname");		 	 
      String incharge = req.getParameter("incharge");		 	 
      int pass1=0;
      String qry1 = "insert into application values ('"+app_id+"','"+app_name+"', null,'"+hname+"','"+incharge+"')";
      Statement stmt1 = myCom.createStatement();  
      pass1=stmt1.executeUpdate(qry1);
      if(pass1 == 0){ 
	pub_key = "no";
	out.println("<center>Record Not Inserted</center>");
      	res.setHeader("refresh","5; URL=/app/appadd.shtml");
      }	   
      else{
	out.println("<center>Record Inserted</center>");
      }	
      // prints a form to upload the public key.
      if(pub_key.equals("yes") || pub_key.equals("")) {
	out.println("<form action=\"/servlets/UploadFile\"  enctype=multipart/form-data method=post>"
	    +"File to upload ? <input type=file name=file><br>"
	    +"<input type=hidden name=app_id value="+app_id
	    +" <br><input type=submit> </form>");

      }
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");			
      res.setHeader("refresh","5; URL=/app/appadd.shtml");
    }	
  }


  /* 
   * This method deletes an application record from the database.
   */
  public static void  DelAppl(HttpServletRequest req,HttpServletResponse res){
    try{
      String att_name = req.getParameter("attribute");		 	 
      String att_value = req.getParameter("value");		 	 
      String qry2 = "delete from application where "+att_name+" = '"+att_value+"'";
      Statement stmt2 = myCom.createStatement();  
      int pass2=stmt2.executeUpdate(qry2);
      if(pass2==0){
	out.println("<center>Error: Invalid Atttribute Value</center>");
	out.println("<center>Record Not Deleted</center>");
	res.setHeader("refresh","5; URL=/app/appdelete.shtml");
      }
      else{
	out.println("<center>Record Deleted</center>");
	res.setHeader("refresh","5; URL=/appwork.shtml");
      } 
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/app/appdelete.shtml");
    }  
  } 

  /*
   * When modification of application data is requested, this methods fills
   * up a form containing the old values, to facilitate modification.
   */
  public static void  FillForm(HttpServletRequest req,HttpServletResponse res){
    try{	
      String app_id=req.getParameter("app_id");
      String qry="select app_id,app_name, hname, incharge from application where app_id = '"+app_id+"'";
      Statement stmt=myCom.createStatement();
      ResultSet rs=stmt.executeQuery(qry);
      String app_name="",pub_key="",hname="",incharge="";
      if(rs.next()){
	app_name=rs.getString("app_name");
	hname=rs.getString("hname");
	incharge=rs.getString("incharge");

	// generation of html page containing form filled with present values	    
	out.println("<form action=/servlets/SysAdFuncs1 "
	    +"Method=get>"
	    +"<input type=hidden name=\"id\" value=\"1.4\">"
	    +"<center>"
	    +"<table border=0 >"
	    +"<tr><td colspan=2 bgcolor=orange>"
	    +"<p align=center>"
	    +"<font color=white>Please enter the values for all the fields"
	    +"</font>"
	    +"</td></tr>"
	    +"<tr><td bgcolor=lightgrey>"
	    +"<p align=right><b>App-id:</b>"
	    +"</td>"
	    +"<td bgcolor=lightblue>"
	    +"<p><input type=hidden name=\"app_id\" Value=\""+app_id+"\" Size=15> &nbsp;&nbsp;"+app_id
	    +"</td></tr>"
	    +""
	    +""
	    +"<tr><td bgcolor=lightgrey>"
	    +"<p align=right><b>App-name:</b>"
	    +"</td>"
	    +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"app_name\" Value=\""+app_name+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b>host-name:</b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"hname\" Value=\""+hname+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b>Incharge:</b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"incharge\" Value=\""+incharge+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b>Change Pub-Key?:</b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=radio name=\"pub_key\" Value=\"no\" checked> No &nbsp;&nbsp;"
	  +"<input type=radio name=\"pub_key\" Value=\"yes\" > Yes"
	  +"</td></tr>"
	  +""
	  +""
	  +"<tr><td colspan=2 bgcolor=green>"
	  +"<center>"
	  +"<font color=white>"
	  +"<input type=submit value=\"  OK   \">"
	  +"</font>"
	  +"</center>"
	  +"</td></tr>"
	  +"</table>"
	  +"</body>" );
      }
      else{
	out.println("<center> The application "+app_id+" Doesn't exist</center>");
	res.setHeader("refresh","5; URL=/app/appmodify.shtml");
      }
    }	
    catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/app/appmodify.shtml");
    }		
  } 



  /*
   * This method is used to modify an application record.  
   */
  public static void  ModifyAppl(HttpServletRequest req, HttpServletResponse res) throws IOException{
    int[] pass=new int[10];
    String app_id = req.getParameter("app_id");
    String app_name = req.getParameter("app_name");
    String pub_key = req.getParameter("pub_key");		 	 
    String hname = req.getParameter("hname");		 	 
    String incharge = req.getParameter("incharge");		 	 
    try{
      Statement stmt = myCom.createStatement();
      pass[0]=stmt.executeUpdate("update application set app_name ='"+app_name+"' where app_id = '"+app_id+"'");
      pass[1]=stmt.executeUpdate("update application set hname ='"+hname+"' where app_id = '"+app_id+"'");
      pass[2]=stmt.executeUpdate("update application set incharge ='"+incharge+"' where app_id = '"+app_id+"'");
      boolean flag=true;
      for(int i=0;i<3;i++){
        if(pass[i]==0){
   	  res.setHeader("refresh","5; URL=/usr/usradd.shtml");
    	  out.println("<center>Record Not Updated</center>");
          flag=false;	
	}
      }	
      if(flag==true){
    	  out.println("<center>Record Updated</center>");
   	  if(pub_key.equals("no")){   
      		res.setHeader("refresh","5; URL=/appwork.shtml");
      	  }	   
      	  else{
      		// prints a form to upload the public key.
		out.println("<form action=\"/servlets/UploadFile\"  enctype=multipart/form-data method=post>"
	    	+"File to upload ? <input type=file name=file><br>"
	    	+"<input type=hidden name=app_id value="+app_id
	    	+" <br><input type=submit> </form>");
	 }
      }
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/app/appmodify.shtml");
    }	  	
  } 
}
