import java.lang.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import PrintPage;

/**
 * This class deals with requests corresponding to the groups menu,
 * The class has methods to handle addition, deletion and modification 
 * of group records.
 * @author bhalotia, vivek
 * */


public class SysAdFuncs2 extends HttpServlet{
  public static java.sql.Connection myCom=null;
  public static PrintWriter out;

  /*
   * This method calls other methods to first check whether the user has 
   * been authenticated, and then calls the appropriate method according
   * to the operation.
   */
  public void doGet(HttpServletRequest req,HttpServletResponse res) throws IOException,ServletException{
    try{
      res.setContentType("text/html");
      out = res.getWriter();
      PrintPage Page=new PrintPage();
      out.println("<center>");
      DBConnect(res);
      boolean authentic=CheckCookie(req,res);			
      if(authentic==false){ //operations not allowed to invalid user.
	Page.putHeader(out,"ERROR: INVALID USER !");
	out.println("<center>You are not allowed to perform this Operation</center>");
	res.setHeader("refresh","5; URL=/login.shtml");
      }
      else{
	// operation is performed according to value of id.
	String id=req.getParameter("id");

	if(id.equals("2.1")){
	  Page.putHeader(out,"Add Groups");
	  AddGroup(req,res);
	}	
	if(id.equals("2.2")){
	  Page.putHeader(out,"Delete Group");
	  DelGroup(req,res);	
	}	
	if(id.equals("2.3")){
	  Page.putHeader(out,"Modify Group");
	  FillForm(req,res);
	}	
	if(id.equals("2.4")){
	  Page.putHeader(out,"Modify Group");
	  ModifyGroup(req,res);
	}	
      }	
      Page.putFooter(out);
      myCom.close();

    }catch(SQLException sqle){
      out.println("<center>SQL Exception" + sqle+"</center>");
      res.setHeader("refresh","5; URL=/grpwork.shtml");
    }	
  }

  /*
   * This method opens a new connection to the database
   */
  private static void DBConnect(HttpServletResponse res){
    try{
      DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
      myCom =
	DriverManager.getConnection("jdbc:oracle:thin:@everest:1521:GEN","userinfo","fighter");
    }
    catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/grpwork.shtml");
    }
  }

  /*
   * This method checks for a cookie for the user both in the browser
   * and in the database, further checking whether they are equal. If so
   * true is returned else false.
   */
  private static boolean CheckCookie(HttpServletRequest req,HttpServletResponse res){
    Cookie[] cooki=req.getCookies();
    for(int i=0;i<cooki.length;i++){
      if(cooki[i].getName().equals("Challenge")){
	String qry="select user_id from cookie_jar where cookie='"+cooki[i].getValue()+"'";
	try{
	  Statement stmt=myCom.createStatement();
	  ResultSet rs=stmt.executeQuery(qry);
	  while(rs.next()){
	    String usr=rs.getString("user_id");
	    // only root is allowed
	    // these functions
	    if(usr.equals("root"))
	      return true;
	  }
	}catch(SQLException sqle){
	  out.println("<center>SQLException :"+sqle+"</center>");
	  res.setHeader("refresh","5; URL=/grpwork.shtml");
	}
      }	
    }
    return false;
  }


  /* 
   * This method adds a new group record to the database.
   */
  public static void AddGroup(HttpServletRequest req,HttpServletResponse res){
    try{		
      String group_id = req.getParameter("group_id");
      String app_id = req.getParameter("app_id");
      String user_id = req.getParameter("user_id");		 	 
      String acc_level = req.getParameter("acc_level");		 	 
      int pass1=0;
      String qry1 = "insert into groups values ('"+group_id+"','"+app_id+"','"+user_id+"',"+acc_level+")";
      Statement stmt1 = myCom.createStatement();  
      pass1=stmt1.executeUpdate(qry1);
      if(pass1==0){
	out.println("<center> Record Not Inserted </center>");
	res.setHeader("refresh","5; URL=/grp/grpadd.shtml");
      }
      else{
	out.println("<center> Record Inserted <center> ");	
	res.setHeader("refresh","5; URL=/grpwork.shtml");
      }
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/grp/grpadd.shtml");
    }	
  }


  /* 
   * This method deletes an application record from the database.
   */
  public static void  DelGroup(HttpServletRequest req,HttpServletResponse res){
    try{		
      String att_name = req.getParameter("attribute");
      String qry2="";
      if(att_name.equals("acc_level")){
	Integer att_value=Integer.valueOf(req.getParameter("value"));	
	qry2 = "delete from groups where "+att_name+" = "+att_value;
      }
      else{	
	String att_value = req.getParameter("value");		 	 
	qry2 = "delete from groups where "+att_name+" = '"+att_value+"'";
      }
      Statement stmt2 = myCom.createStatement();  
      int pass2=stmt2.executeUpdate(qry2);
      if(pass2==0){
	out.println("<center>Error: Invalid Atttribute Value</center>");
	out.println("<center>Record Not Deleted</center>");
	res.setHeader("refresh","5; URL=/grp/grpdelete.shtml");
      }
      else{
	out.println("<center>Record Deleted</center>");
	res.setHeader("refresh","5; URL=/grpwork.shtml");
      } 
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/grp/grpdelete.shtml");
    }  
  } 


  /*
   * When modification of application data is requested, this methods fills
   * up a form containing the old values, to facilitate modification.
   */
  public static void  FillForm(HttpServletRequest req,HttpServletResponse res){
    try{
      String group_id=req.getParameter("group_id");
      String qry="select * from groups where group_id = '"+group_id+"'";
      Statement stmt=myCom.createStatement();
      ResultSet rs=stmt.executeQuery(qry);
      String user_id="",app_id="";
      Integer acc_level=new Integer(0);
      if(rs.next()){
	user_id=rs.getString("user_id");
	app_id=rs.getString("app_id");
	acc_level=Integer.valueOf(rs.getString("acc_level"));

	// generation of html page containing form filled with present values	    
	out.println("<form action=/servlets/SysAdFuncs2 "
	    +"Method=get>"
	    +"<input type=hidden name=\"id\" value=\"2.4\">"
	    +"<center>"
	    +"<table border=0 >"
	    +"<tr><td colspan=2 bgcolor=orange>"
	    +"<p align=center>"
	    +"<font color=white>Please enter the values for all the fields"
	    +"</font>"
	    +"</td></tr>"
	    +"<tr><td bgcolor=lightgrey>"
	    +"<p align=right><b><font color=black>Group-id:</font></b>"
	    +"</td>"
	    +"<td bgcolor=lightblue>"
	    +"<p><input type=text name=\"group_id\" Value=\""+group_id+"\" Size=15>"
	    +"</td></tr>"
	    +""
	    +""
	    +"<tr><td bgcolor=lightgrey>"
	    +"<p align=right><b><font color=black>App-id:</font></b>"
	    +"</td>"
	    +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"app_id\" Value=\""+app_id+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>User-id:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"user_id\" Value=\""+user_id+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>Access-Level:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"acc_level\" Value=\""+acc_level+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +""
	  +"<tr><td colspan=2 bgcolor=green>"
	  +"<center>"
	  +"<input type=submit value=\"  OK   \">"
	  +"</center>"
	  +"</td></tr>"
	  +"</table>"
	  +"</body>"
	  +""
	  +"");
      }	
      else {
	out.println("<center> The Group "+group_id+" Doesn't exist</center>");
	res.setHeader("refresh","5; URL=/grp/grpmodify.shtml");
      }
    }

    catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/grp/grpmodify.shtml");
    }		
  } 

  /*
   * This method is used to modify an application record.  
   */
  public static void  ModifyGroup(HttpServletRequest req,HttpServletResponse res){
    String group_id = req.getParameter("group_id");
    String app_id = req.getParameter("app_id");
    String user_id = req.getParameter("user_id");		 	 
    Integer acc_level = Integer.valueOf(req.getParameter("acc_level"));		 	 
    String qry="delete from groups where group_id = '"+group_id+"'";
    try{
      Statement stmt = myCom.createStatement();
      int pass=stmt.executeUpdate(qry);
      AddGroup(req,res);
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/grp/grpmodify.shtml");
    }	  	
  } 
}
