import java.lang.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import PassField;
import PrintPage;

/**
 * This class deals with requests corresponding to the user menu,
 * The class has methods to handle addition, deletion and modification of
 * user records.
 * @author vivek, bhalotia
 * */
public class SysAdFuncs3 extends HttpServlet{
  public static java.sql.Connection myCom=null;
  public static PrintWriter out;
  public static String passwd,passw;

  /** 
   * For insecure mode of access.
   * */ 
  public void doPost(HttpServletRequest req,HttpServletResponse res) throws IOException,ServletException{
    passw=req.getParameter("passwd");
    passwd=(new PassField()).getChallenge(passwd);
    CommonFuncs(req,res);
  }

  /** 
   * For secure mode of access.
   * */ 
  public void doGet(HttpServletRequest req,HttpServletResponse res) throws IOException,ServletException{
    passwd=req.getParameter("challenge");
    CommonFuncs(req,res);
  }

  /*
   * This method calls other methods to first check whether the user has 
   * been authenticated, and then calls the appropriate method according
   * to the operation.
   */
  public void CommonFuncs(HttpServletRequest req,HttpServletResponse res) throws IOException,ServletException{
    try{
      res.setContentType("text/html");
      out = res.getWriter();
      PrintPage Page=new PrintPage();
      DBConnect(res);
      boolean authentic=CheckCookie(req,res);			
      if(authentic==false){  // operation not allowed to invalid user
	Page.putHeader(out,"ERROR: INVALID USER ");
	out.println("<center>You are not allowed to perform this Operation</center>");
	res.setHeader("refresh","5; URL=/login.shtml");
      }
      else{
	// operation performed according to value of hidden field - id
	String id=req.getParameter("id");

	if(id.equals("3.1")){
	  Page.putHeader(out,"Add Users");
	  AddUser(req,res);
	}	
	if(id.equals("3.2")){
	  Page.putHeader(out,"Delete Users");
	  DelUser(req,res);	
	}	
	if(id.equals("3.3")){
	  Page.putHeader(out,"Modify Users");
	  FillForm(req,res);
	}	
	if(id.equals("3.4")){
	  Page.putHeader(out,"Modify Users");
	  ModifyUser(req,res);
	}	
      }	
      Page.putFooter(out);	
      myCom.close();

    }catch(SQLException sqle){
      out.println("<center>SQL Exception" + sqle+"</center>");
      res.setHeader("refresh","5; URL=/usrwork.shtml");
    }	
  }
  /* 
   * This method opens a connection to the database.
   */
  private static void DBConnect(HttpServletResponse res){
    try{
      DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
      myCom =
	DriverManager.getConnection("jdbc:oracle:thin:@everest:1521:GEN","userinfo","fighter");
    }
    catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/usrwork.shtml");
    }
  }

  /*
   * This method checks for a cookie for the user both in the browser
   * and in the database, further checking if they are equal. If so
   * true is returned else false.
   */
  private static boolean CheckCookie(HttpServletRequest req,HttpServletResponse res){
    Cookie[] cooki=req.getCookies();
    for(int i=0;i<cooki.length;i++){
      if(cooki[i].getName().equals("Challenge")){
	try{
	  String qry="select user_id from cookie_jar where cookie='"+cooki[i].getValue()+"'";
	  Statement stmt=myCom.createStatement();
	  ResultSet rs=stmt.executeQuery(qry);
	  while(rs.next()){
	    String usr=rs.getString("user_id");
	    if(usr.equals("root"))
	      return true;
	  }
	}catch(SQLException sqle){
	  out.println("<center>SQLException :"+sqle+"</center>");
	  res.setHeader("refresh","5; URL=/usrwork.shtml");
	}
      }	
    }
    return false;
  }

  /* 
   * This method adds a new user record to the database.
   */
  public static void AddUser(HttpServletRequest req, HttpServletResponse res){
    try{	
      String user_id = req.getParameter("user_id");
      String u_name = req.getParameter("u_name");
      String roll_no = req.getParameter("roll_no");		 	 
      String dob = req.getParameter("dob");		 	 
      String perm_add = req.getParameter("perm_add");		 	 
      String local_add = req.getParameter("local_add");		 	 
      String email_id = req.getParameter("email_id");		 	 
      int pass1=0;
      String qry1 = "insert into users values ('"+user_id+"','"+u_name+"','"+roll_no+"','"+dob+"','"+perm_add+"','"+local_add+"','"+email_id+"','"+passwd+"')";
      Statement stmt1 = myCom.createStatement();  
      pass1=stmt1.executeUpdate(qry1);
      if(pass1==0){
	res.setHeader("refresh","5; URL=/usr/usradd.shtml");
	out.println("<center>Record Not Inserted</center>");
      }else{
	res.setHeader("refresh","5; URL=/usrwork.shtml");
	out.println("<center>Record Inserted</center>");
      }	
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/usr/usradd.shtml");
    }	
  }



  /* 
   * This method deletes an application record from the database.
   */
  public static void  DelUser(HttpServletRequest req, HttpServletResponse res){
    try{
      String att_name = req.getParameter("attribute");		 	 
      String att_value = req.getParameter("value");		 	 
      String qry2 = "delete from users where "+att_name+" = '"+att_value+"'";
      Statement stmt2 = myCom.createStatement();  
      int pass2=stmt2.executeUpdate(qry2);
      if(pass2==0){
	out.println("<center>Error: Invalid Atttribute Value</center>");
	out.println("<center>Record Not Deleted</center>");
	res.setHeader("refresh","5; URL=/usr/usrdelete.shtml");
      }
      else{
	out.println("<center>Record Deleted</center>");
	res.setHeader("refresh","5; URL=/usrwork.shtml");
      } 
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/usr/usrdelete.shtml");
    }  
  }

  /*
   * When modification of application data is requested, this methods fills
   * up a form containing the old values, to facilitate modification.
   */
  public static void  FillForm(HttpServletRequest req,HttpServletResponse res){
    try{
      String user_id=req.getParameter("user_id");
      String qry="select * from users where user_id = '"+user_id+"'";
      Statement stmt=myCom.createStatement();
      ResultSet rs=stmt.executeQuery(qry);
      String u_name="",roll_no="",dob="",perm_add="",local_add="",email_id="",passwd="";
      if(rs.next()){
	u_name=rs.getString("u_name");
	roll_no=rs.getString("roll_no");
	dob=rs.getString("dob");
	perm_add=rs.getString("perm_add");
	local_add=rs.getString("local_add");
	email_id=rs.getString("email_id");
	passwd=rs.getString("passwd");

	// generation of html page containing form filled with present values	    
	out.println("<form action=/servlets/SysAdFuncs3 "
	    +"Method=get>"
	    +"<input type=hidden name=\"id\" value=\"3.4\">"
	    +"<center>"
	    +"<table border=0 >"
	    +"<tr><td colspan=2 bgcolor=orange>"
	    +"<p align=center>"
	    +"<font color=white>Please enter the values for all the fields"
	    +"</font>"
	    +"</td></tr>"
	    +"<tr><td bgcolor=lightgrey>"
	    +"<p align=right><b><font color=black>User-id:</font></b>"
	    +"</td>"
	    +"<td bgcolor=lightblue>"
	    +"<p><input type=hidden name=\"user_id\" Value=\""+user_id+"\" Size=15> &nbsp;&nbsp "+ user_id
	    +"</td></tr>"
	    +""
	    +""
	    +"<tr><td bgcolor=lightgrey>"
	    +"<p align=right><b><font color=black>User-name:</font></b>"
	    +"</td>"
	    +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"u_name\" Value=\""+u_name+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>Roll-No:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"roll_no\" Value=\""+roll_no+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>Birth-Date:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"dob\" Value=\""+dob+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>Perm-Add:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"perm_add\" Value=\""+perm_add+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>Local-Add:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"local_add\" Value=\""+local_add+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<tr><td bgcolor=lightgrey>"
	  +"<p align=right><b><font color=black>email-id:</font></b>"
	  +"</td>"
	  +"<td bgcolor=lightblue>"
	  +"<p><input type=text name=\"email_id\" Value=\""+email_id+"\" Size=15>"
	  +"</td></tr>"
	  +""
	  +"<p><input type=hidden name=\"passwd\" Value=\""+passwd+"\" Size=15>"
	  +""
	  +""
	  +"<tr><td colspan=2 bgcolor=green>"
	  +"<center>"
	  +"<input type=submit value=\"  OK   \">"
	  +"</center>"
	  +"</td></tr>"
	  +"</table>"
	  +"</body>"
	  );
      }
      else{
	out.println("<center>The user "+user_id+" does not exist</center>");
	res.setHeader("refresh","5; URL=/usr/usradd.shtml");
      }	
    }	
    catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/usr/usrmodify.shtml");
    }		

  } 

  /*
   * This method is used to modify an application record.  
   */
  public static void  ModifyUser(HttpServletRequest req, HttpServletResponse res){
    int[] pass=new int[10];
    String user_id = req.getParameter("user_id");
    String u_name = req.getParameter("u_name");
    String roll_no = req.getParameter("roll_no");		 	 
    String dob = req.getParameter("dob");		 	 
    String perm_add = req.getParameter("perm_add");		 	 
    String local_add = req.getParameter("local_add");		 	 
    String email_id = req.getParameter("email_id");		 	 
    //	String passwd = req.getParameter("passwd");		 	 
    try{		
      Statement stmt = myCom.createStatement();
      pass[0]=stmt.executeUpdate("update users set u_name ='"+u_name+"' where  user_id = '"+user_id+"'");
      pass[1]=stmt.executeUpdate("update users set roll_no ='"+roll_no+"' where  user_id = '"+user_id+"'");
      pass[2]=stmt.executeUpdate("update users set dob ='"+dob+"' where  user_id = '"+user_id+"'");
      pass[3]=stmt.executeUpdate("update users set perm_add ='"+perm_add+"' where  user_id = '"+user_id+"'");
      pass[4]=stmt.executeUpdate("update users set local_add ='"+local_add+"' where  user_id = '"+user_id+"'");
      pass[5]=stmt.executeUpdate("update users set email_id ='"+email_id+"' where  user_id = '"+user_id+"'");
      boolean flag=true;
      for(int i=0;i<6;i++){
        if(pass[i]==0){
   	  res.setHeader("refresh","5; URL=/usr/usradd.shtml");
    	  out.println("<center>Record Not Updated</center>");
          flag=false;	
	}
      }	
      if(flag==true){
   	  res.setHeader("refresh","5; URL=/usrwork.shtml");
    	  out.println("<center>Record Updated</center>");
      }	
    }catch(SQLException sqle){
      out.println("<center>SQLException :"+sqle+"</center>");
      res.setHeader("refresh","5; URL=/usr/usrmodify.shtml");
    }	  	
  } 
}
