import java.io.*;
import java.io.File;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import PrintPage;

/**
 * This class uploads a file taking the parameter specified by the file
 * name from the HttpServletRequest stream
 * @author bhalotia, sandy
 */
public class UploadFile extends HttpServlet {

  public void doPost(HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException {
      res.setContentType("text/html");
      PrintWriter out = res.getWriter();
      PrintPage Page = new PrintPage();

      try {

	MultipartRequest multi =
	  new MultipartRequest(req, "/users/ug97/bhalotia/tmp/", 5 * 1024 * 1024);

	Page.putHeader(out, "File Uploaded");
	// Print the parameters we received
	out.println("<center><H3>Params:</H3>");
	out.println("<PRE>");
	Enumeration params = multi.getParameterNames();
	while (params.hasMoreElements()) {
	  String name = (String)params.nextElement();
	  String value = multi.getParameter(name);
	  out.println(name + " = " + value);
	}
	out.println("</PRE>");

	// Show which files we received
	out.println("<H3>Files:</H3>");
	out.println("<PRE>");
	Enumeration files = multi.getFileNames();
	while (files.hasMoreElements()) {
	  String name = (String)files.nextElement();
	  String filename = multi.getFilesystemName(name);
	  String type = multi.getContentType(name);
	  File f = multi.getFile(name);
	  out.println("name: " + name);
	  out.println("filename: " + filename);
	  out.println("type: " + type);
	  if (f != null) {
	    out.println("length: " + f.length());
	    out.println();
	  }
	  out.println("</PRE>");
	}
	String app_id = multi.getParameter("app_id");
	boolean result=CipherServer.putClientPublicKey(out, app_id, multi.key);
	out.println(app_id+" "+result);

	//Writing this file into the specified directory using the file
	//name as the application's id
	FileOutputStream fs=new FileOutputStream("/tmp/bhalotia/"+app_id);
	fs.write(multi.key);
      }
      catch (Exception e) {
	out.println("<PRE>");
	e.printStackTrace(out);
	out.println("</PRE></center>");
      }
      //refresh to the main menu for application
      res.setHeader("refresh","5;URL=/appwork.shtml");
      Page.putFooter(out);
    }
}
